function [cx,cy,cc] = lineartri(p,q,r,a,b,c)
%LINEAR_ON_TRI  return coefficients of a linear fcn on a triangle
%  the function has value a at p, b at q and c at r
 
  a1 = q(2) - r(2);
  b1 = -q(1) + r(1);
  c1 = -a1*r(1) - b1*r(2);
  d1 = 1./(a1*p(1) + b1*p(2) + c1);
  a1 = d1*a1;  b1 = d1*b1;  c1 = d1*c1;

  
  a2 = r(2) - p(2);
  b2 = -r(1) + p(1);
  c2 = -a2*r(1) - b2*r(2);
  d2 = 1./(a2*q(1) + b2*q(2) + c2);
  a2 = d2*a2;  b2 = d2*b2;  c2 = d2*c2;
  
  a3 = p(2) - q(2);
  b3 = -p(1) + q(1);
  c3 = -a3*p(1) - b3*p(2);
  d3 = 1./(a3*r(1) + b3*r(2) + c3);
  a3 = d3*a3;  b3 = d3*b3;  c3 = d3*c3;

  cx = a*a1 + b*a2 + c*a3;
  cy = a*b1 + b*b2 + c*b3;
  cc = a*c1 + b*c2 + c*c3;
